'FFSubmenu=Exif
'FFName=Search Exif
' search_exif.vbs
'*********************************************************
' Exif Suche v1.7
' (C) Zaph 07/2005
' Email: zaphl@gmx.de
'
' ablauffhig ab Fixfoto V2.85 Release
' Fixfoto: http://www.j-k-s.com
'*********************************************************
' Exif-Suche ermglicht die Suche nach Begriffen in den
' Exif-Feldern von JPG-Bildern.
'
' Nach erfolgter Suche knnen die Bilder:
' - durchgesehen,
' - in ein Verzeichnis kopiert,
' - eine Bilderliste erzeugt,
' - oder die Exif-Daten in eine CVS-Datei exportiert werden
'
' Eingabe ist der Suchbegriff, der Name des Exif-Feldern und
' die Suchtiefe.
'
' Bei den Suchbegriffen werden die Wildcards "*" und "?"
' untersttzt:
' "*" steht fr beliebige Zeichen
' "?" steht fr genau ein Zeichen
' Beispiel:
' "1??" findet "100" und "147", aber nicht "210" oder "10"
' "1*" findet "100", "147" und "10", aber nicht "210"
' "*1* findet "100", "147", "10" und "210"
' "*" findet alle Eintrge (auch leere)
'
' Die Suchtiefe erstreckt sich entweder auf die markierten
' Bilder, auf ein gesamtes Verzeichnis oder ein
' Verzeichnis incl. aller Unterverzeichnisse
'
' nderungen:
' V1.1: Weitervearbeitung der Suchergebnisse (s.o.)
' V1.2:
'	- Suchverzeichnis selektierbar
'	- Script aufrufbar auch ohne selektierte Bilder
' V1.3: Anpassungen an FF V2.71 B:31
' V1.4: UserComment hinzugefgt, Bug in Versionsabfrage gefixt
' V1.5: Bilderliste erzeugen
' V1.6: Dirk Forst, Operator fr Zahlenvergleiche implementiert
' V1.7: Dirk Forst, richtige Datumsvergleiche inkl Zeit implementiert

option explicit

' Globale Variablen
dim fPics()
dim sPics()
dim pic, startFolder
'dim file, ext
dim searchLevel
dim operatorDef
dim searchStr, exifTagDef, exifTagNo, operatorStr
dim exifTagList
Const cmdOK = "OK"
Const cmdCancel = "Abbrechen"
Const WS_TABSTOP = &H10000
Const WS_VSCROLL = &H200000

' Defaulteinstellungen
searchStr = ""
searchLevel = 0
operatorDef = "="
exifTagDef = "Kommentar"
operatorStr = operatorDef

Call Main

sub Main
	dim ok
	' Version checken
	if not CheckBuild("2.85.000") then
		msgbox "Dieses Script luft erst ab FF Version 2.85 (Release) - Abbruch!", vbCritical, "EXIF Suche"
		exit sub
	end if

	' Exif-Tagliste aufbauen
	buildExifList exifTagList

	' solange Dialoge anzeigen, bis "Abbruch" gedrckt wird
	do
		ok = true
		enterSearch searchStr, operatorStr, exifTagNo, searchLevel, startfolder
		if searchStr <> "" then
			buildFileList startFolder, searchLevel, sPics
			if sPics(0) <> "" then
				executeSearch searchStr, operatorStr, exifTagNo, sPics, fPics
				if fPics(0) <> "" then
					ok = showPics(fPics, exifTagNo)
				else
					msgbox "Keine passenden Bilder gefunden!", vbExclamation, "EXIF Suche"
				end if
			else
				msgbox "Keine JPG-Bilder gefunden!", vbExclamation, "EXIF Suche"
			end if
		else
			ok = false
		end if
	loop until not ok
end sub

' Ende Hauptprogramm

'*********************************************************
' buildExifList baut die Exif-Tagliste auf
' exifTagList: dynamisches Array mit den Exif-Tagnamen
'*********************************************************
sub buildExifList (exifTagList)
	addList2 exifTagList,"DateTime","nderungsdatum"
	addList2 exifTagList,"DateTimeOriginal","Aufnahmedatum"
	addList2 exifTagList,"DateTimeDigitized","Digitalisierungsdatum"

	addList2 exifTagList,"ImageDescription","Beschreibung"
	addList2 exifTagList,"UserComment","Kommentar"
	addList2 exifTagList,"Copyright1","Copyright 1"
	addList2 exifTagList,"Copyright2","Copyright 2"
	addList2 exifTagList,"ApertureValue","Blende (ApertureValue)"
	addList2 exifTagList,"FNumber","Blende (FNumber)"
	addList2 exifTagList,"Artist","Fotograf"

	addList2 exifTagList,"BrightnessValue","Helligkeit"
	addList2 exifTagList,"ExposureBiasValue","Belichtungskorrektur"
	addList2 exifTagList,"ExposureIndex","Belichtungsindex"
	addList2 exifTagList,"ExposureProgram","Belichtungsprogramm (numerisch)"
	addList2 exifTagList,"ExposureTime","Belichtungszeit (ExposureTime)"
	addList2 exifTagList,"ShutterSpeedValue","Belichtungszeit (ShutterSpeedValue)"
	addList2 exifTagList,"Flash","Blitz"
	addList2 exifTagList,"FocalLength","Brennweite"
	addList2 exifTagList,"ISOSpeedRatings","ISO Wert"
	addList2 exifTagList,"LightSource","Lichtquelle"
	addList2 exifTagList,"MaxApertureValue","Maximale Blende"
	addList2 exifTagList,"MeteringMode","Messmethode"
	addList2 exifTagList,"SubjectDistance","Objektentfernung"
	addList2 exifTagList,"Orientation","Orientierung"

	addList2 exifTagList,"Make","Hersteller"
	addList2 exifTagList,"Model","Modell"
	addList2 exifTagList,"Software","Software"

	addList2 exifTagList,"ResolutionUnit","Auflsungseinheit"
	addList2 exifTagList,"XResolution","X-Auflsung"
	addList2 exifTagList,"YResolution","Y-Auflsung"
end sub

'*********************************************************
' addList2 fgt einem zweidimensionale dynamisches Array
' einen Listeneintrag hinzu
' list:  dynamische Array der Dimension (1,x)
' term1: Listeneintrag fr die erste Dimension
' term2: Listeneintrag fr die zweite Dimension
'*********************************************************
sub addList2(byref list, term1, term2)
	if isempty(list) then
		redim list(1,0)
	else
		redim preserve list(1,ubound(list,2)+1)
	end if
	list(0,ubound(list,2))=term1
	list(1,ubound(list,2))=term2
end sub

'*********************************************************
' buildFileList baut eine Dateiliste auf (JPG-Dateien)
' startFolder : Startverzeichnis
' searchLevel : 0 = markierte Bilder
'               1 = aktuelles Verzeichnis
'               2 = aktuelles und alle Unterverzeichnisse
' pics        : Array mit den gefundenen Pfadnamen
'*********************************************************
sub buildFileList(startFolder, searchLevel, byref pics)
	dim oFindF
	dim recursive
	dim i, msg
	redim preserve pics(0)
	pics(0) = ""
	if searchLevel = 0 then
		for i=0 to FF_GetImageCount-1
			redim preserve pics(i)
			pics(i) = FF_GetImageName(i)
		next
	else
		recursive = eval(searchLevel=2)
		set oFindF = new clsFindFile
		oFindF.findFiles startFolder, "\.jpg$", recursive, pics
		set oFindF = nothing
	end if
end sub

'*********************************************************
' executeSearch durchsucht die gefundenen Dateien und
' filtert die heraus, wo der Suchbegriff im Exiftag vorkommt
' searchStr   : Suchbegriff (Wildcards erlaubt)
' operatorStr : Operator
' exifTagNo   : Nummer des Exiftag, in dem der Suchbegriff gesucht wird
' sPics       : Array mit den zu durchsuchenden Pfadnamen
' fPics       : Array mit den gefundenen Pfadnamen
'*********************************************************
sub executeSearch(searchStr, operatorStr, exifTagNo, byref sPics, byref fPics)

	dim msg, path, exifData, exifTag
	dim pattnr
	dim i, npics, gpics

	redim preserve fPics(0)
	fPics(0) = ""
	pattnr = Replace(searchStr, "*", ".*")
	pattnr = Replace(pattnr, "?", ".")
	npics = 0
	gpics = ubound(sPics)
	for i=0 to gpics
		FF_SetProgress i, gpics
		FF_LoadExif sPics(i)
		exifTag = exifTagList(0,exifTagNo)
		exifData = FF_GetExifTag(exifTag)
		
		'if RegExpTest(exifdata, pattnr) then
		if checkExifDate(exifTag, exifData, pattnr, operatorStr) then
			redim preserve fPics(npics)
			fPics(npics) = sPics(i)
			npics = npics + 1
		end if
	next
	FF_SetProgress 0, gpics

end sub


'*********************************************************
' enterSearch: Dialogmaske zur Eingabe des Suchbegriffes u.a.
' searchStr   : Suchbegriff (Wildcards erlaubt)
' operatorStr : Operator
' exifTagNo   : Nummer des Exiftag, in dem der Suchbegriff gesucht wird
' searchLevel : 0 = markierte Bilder
'               1 = ein Verzeichnis (default: aktuelles Computerverzeichnis)
'               2 = ein Verzeichnis und dessen Unterverzeichnisse
'*********************************************************
sub enterSearch(searchStr, operatorStr, exifTagNo, searchLevel, startfolder)

	Dim fx,fy,dfx,dfy,fh,dw,dh
	Dim DialogEnde, i

	const dlgEnter = "EXIF Suche - Eingabe"
	const cmbOperator = "cmbOperator"
	const cmbExif = "cmbExif"
	const cmbSearch = "cmbSearch"

	Dim SLv(2)
	Dim SOp(4)

	SLv(0) = "Markierte Bilder"
	SLv(1) = "Verzeichnis"
	SLv(2) = "Verzeichnis mit Unterverzeichnissen"

	SOp(0) = "="
	SOp(1) = "<"
	SOp(2) = ">"
	SOp(3) = "<="
	SOp(4) = ">="
	
	' Fensterabmessungen
	dw = 164
	dh = 80
	' linke obere Ecke im Dialogfenster
	fx = 5
	fy = 5
	' Abstand zwischen zwei Dialogzeilen
	dfy = 15
	' Abstand zwischen zwei Spalten
	dfx = 50
	' Hhe einer Dialogzeile
	fh = 10

	' Dialog erzeugen
	FF_AddDialog dlgEnter, dw, dh

	FF_AddControl dlgEnter, "Suchen in Exif-Feld:", "STATIC", fx, fy, dfx, fh
	FF_AddControl dlgEnter, cmbExif, "COMBO", dfx+5, fy, 100, fh
	for i = 0 to ubound(exifTagList,2)
		FF_SetControl dlgEnter, cmbExif, exifTagList(1,i)
	next
	FF_SetControl dlgEnter, cmbExif, ExifTagDef
	FF_SetControlStyle dlgEnter, cmbExif, WS_TABSTOP + WS_VSCROLL

	fy = fy + dfy
	FF_AddControl dlgEnter, "Operator:", "STATIC", fx, fy, dfx, fh
	FF_AddControl dlgEnter, cmbOperator, "COMBO", dfx+5, fy, 100, fh
	for i = 0 to ubound(SOp)
		FF_SetControl dlgEnter, cmbOperator, SOp(i)
	next
	FF_SetControl dlgEnter, cmbOperator, operatorDef
	FF_SetControlStyle dlgEnter, cmbOperator, WS_TABSTOP + WS_VSCROLL

	fy = fy + dfy
	FF_AddControl dlgEnter, "Suchbegriff:", "STATIC", fx, fy, dfx, fh
	FF_AddControl dlgEnter, "txtSearch", "EDIT", dfx+5, fy, 100, fh
	FF_SetControl dlgEnter, "txtSearch", searchStr

	fy = fy + dfy
	FF_AddControl dlgEnter, "Suchtiefe:", "STATIC", fx, fy, dfx, fh
	FF_AddControl dlgEnter, cmbSearch, "COMBO", dfx+5, fy, 100, fh
	FF_SetControl dlgEnter, cmbSearch, SLv(2)
	FF_SetControl dlgEnter, cmbSearch, SLv(1)
	FF_SetControl dlgEnter, cmbSearch, SLv(0)
	FF_SetControl dlgEnter, cmbSearch, SLv(searchLevel)
	FF_SetControlStyle dlgEnter, cmbSearch, WS_TABSTOP

	' OK, Cancel
	FF_AddControl dlgEnter, cmdOK, "BUTTON", dw-90, dh-13, 40, fh
	FF_AddControl dlgEnter, cmdCancel, "BUTTON", dw-45, dh-13, 40, fh

	FF_ActivateControl dlgEnter, "txtSearch"

	enabledOperator dlgEnter, cmbOperator, getExifTagNo(ExifTagDef)

	' solange Dialog anzeigen, bis "OK" oder "Abbrechen" gedrckt wurde
	dialogEnde = false
	do
		FF_RefreshDialog dlgEnter
		
		' Dialog ffnen
		select case FF_ShowDialog(dlgEnter)
		case cmbExif
			exifTagNo = getExifTagNo(FF_GetControl(dlgEnter, cmbExif))
			enabledOperator dlgEnter, cmbOperator, exifTagNo
			
		case cmdCancel
			searchStr = ""
			dialogEnde = true
		
		case cmdOK
			searchStr = FF_GetControl(dlgEnter, "txtSearch")
			operatorStr = FF_GetControl(dlgEnter, cmbOperator)			
			
			if searchStr <> "" then
				exifTagNo = getExifTagNo(FF_GetControl(dlgEnter, cmbExif))
				exifTagDef = exifTagList(1,exifTagNo)
				operatorDef = operatorStr
				
				select case FF_GetControl(dlgEnter, cmbSearch)
				case SLv(0)
					' Startverzeichnis ermitteln
					if FF_GetImageCount > 0 then
'						SplitPath FF_GetImageName(0), startFolder, file, ext
						searchLevel = 0
						dialogEnde = true
					else
						msgbox "Es sind keine Bilder markiert!", vbExclamation, "EXIF Suche"
					end if
				case SLv(1)
					startfolder = FF_EnterPath(false, "Bitte zu durchsuchendes Verzeichnis angeben!")
					if startfolder <> "" then
						searchLevel = 1
						dialogEnde = true
					end if
				case SLv(2)
					startfolder = FF_EnterPath(false, "Bitte Startverzeichnis fr rekursive Suche angeben!")
					if startfolder <> "" then
						searchLevel = 2
						dialogEnde = true
					end if
				end select
			else
				msgbox "Bitte einen Suchbegriff eingeben!", vbExclamation, "EXIF Suche"
			end if
		end select

	loop until dialogEnde
	
	' Dialog schliessen
	FF_CloseDialog dlgEnter
end sub

function getExifTagNo(tag)
	dim i
	i = -1
	for i=0 to ubound(exifTagList,2)
		if exifTagList(1,i) = tag then
			getExifTagNo = i
			exit function
		end if
	next
end function

'*********************************************************
' showPics zeigt die gefundenen Bilder in einer Maske an
' und bietet weitere Aktionen
' exifTagNo  : Nummer des Exiftag, in dem der Suchbegriff gesucht wird
' pics       : Array mit den anzuzeigenden Pfadnamen
'*********************************************************
function showPics(pics, exifTagNo)
	Dim DialogEnde
	Dim fx,fy,dfx,dfy,fh,dh,dw
	Dim picn, picix
	Dim proz
	Dim tmp

	const dlgRsl = "EXIF Suche - Ergebnisse"
	const imgPic = "PIC"
	const cmdFirst = "<<"
	const cmdPrev = "<"
	const cmdNext = ">"
	const cmdLast = ">>"
	const cmdCopy = "Bilder kopieren"
	const cmdCSV = "CSV-Datei erzeugen"
	const cmdBList = "Bilderliste erzeugen"
	const cmdShowExif = "EXIF?"

	picn = ubound(pics)

	' linke obere Ecke im Dialogfenster
	fx = 5
	fy = 5
	' Abstand zwischen zwei Dialogzeilen
	dfy = 15
	' Breite der Anzeige
	dfx = 200
	' Hhe einer Dialogzeile
	fh = 10
	' Fensterabmessungen
	dw = dfx+(2*fx)
	dh = 210

	' Dialog erzeugen
	FF_AddDialog dlgRsl, dw, dh
	FF_AddControl dlgRsl, "txtFname", "EDIT", fx, fy, dfx, fh
	FF_EnableControl dlgRsl, "txtFname", false

	fy = fy + dfy
	FF_AddControl dlgRsl, imgPic, "IMAGE", fx+25, fy, 150, 100
	FF_SetControl dlgRsl, imgPic, pics(0)
	fy = fy + 100 + 5
	FF_AddControl dlgRsl, cmdFirst, "BUTTON", fx+50, fy, 22, fh
	FF_AddControl dlgRsl, cmdPrev, "BUTTON", fx+76, fy, 22, fh
	FF_AddControl dlgRsl, cmdNext, "BUTTON", fx+102, fy, 22, fh
	FF_AddControl dlgRsl, cmdLast, "BUTTON", fx+128, fy, 22, fh
	FF_AddControl dlgRsl, cmdShowExif, "BUTTON", fx+178, fy, 22, fh
	fy = fy + dfy
	FF_AddControl dlgRsL, "txtCount", "EDIT", fx+25, fy, 150, fh
	'FF_EnableControl dlgRsl, "txtCount", false
	FF_SetControlStyle dlgRsl, "txtCount", 1 + 2048

	fy = fy + dfy
	FF_AddControl dlgRsl, ExifTagList(1,ExifTagNo) & ":", "STATIC", fx, fy, dfx, fh
	fy = fy + 10
	FF_AddControl dlgRsl, "txtExif", "EDIT", fx, fy, dfx, fh
	FF_SetControlStyle dlgRsl, "txtExif", 2048

	fy = fy + dfy
	FF_AddControl dlgRsl, "Aktionen:", "STATIC", fx, fy, 25, fh
	FF_AddControl dlgRsl, cmdCopy, "BUTTON", fx+25, fy, 55, fh
	FF_AddControl dlgRsl, cmdCSV, "BUTTON", fx+85, fy, 55, fh
	FF_AddControl dlgRsl, cmdBList, "BUTTON", fx+145, fy, 55, fh

	' OK, Cancel
	FF_AddControl dlgRsl, cmdOK, "BUTTON", dw-90, dh-13, 40, fh
	FF_AddControl dlgRsl, cmdCancel, "BUTTON", dw-45, dh-13, 40, fh

	proz = CDbl(picn + 1) * 100 / CDbl(UBound(sPics) + 1)

	picix = 0
	' solange Dialog anzeigen, bis "OK" oder "Abbrechen" gedrckt wurde
	dialogEnde = false
	do
		' Dialog ffnen
		FF_LoadExif(pics(picix))

		tmp = FF_GetExifTag(exifTagList(0,ExifTagNo))
		tmp = Replace(tmp, vbCrLf, " ")
		if exifTagList(0,exifTagNo) = "ExposureTime" then
			tmp = formatExposureTime(tmp)
		else		
			tmp = formatDate(tmp)
		end if
			
		FF_SetControl dlgRsl, imgPic, pics(picix)
		FF_SetControl dlgRsl, "txtCount", "Bild " & picix + 1 & " von " & picn + 1 & " (insg. " & UBound(sPics) + 1 & ", " & CLng(proz) & "%)"
		FF_SetControl dlgRsl, "txtFname", pics(picix)
		FF_SetControl dlgRsl, "txtExif", tmp
		FF_EnableControl dlgRsl, cmdFirst, eval(picix > 0)
		FF_EnableControl dlgRsl, cmdPrev, eval(picix > 0)
		FF_EnableControl dlgRsl, cmdNext, eval(picix < picn)
		FF_EnableControl dlgRsl, cmdLast, eval(picix < picn)
		
		select case FF_ShowDialog(dlgRsl)
		case cmdFirst
			picix = 0
		case cmdPrev
			picix = picix - 1
		case cmdNext
			picix = picix + 1
		case cmdLast
			picix = picn
		case cmdCopy
'			FF_CloseDialog dlgRsl
			copyPics pics
		case cmdCSV
			exportCsv pics
		case cmdBList
			CreateBList pics
		case cmdShowExif
			showFileExif pics(picix)
		case cmdCancel
			showPics = false
			dialogEnde = true
		case cmdOK
			showPics = true
			dialogEnde = true
		end select

	loop until DialogEnde
	
	' Dialog schliessen
	FF_CloseDialog dlgRsl
end function

'*********************************************************
' showFileExif zeigt die Exifdaten einer Bilddatei an
' file: Dateiname des Bildes
'*********************************************************
sub showFileExif(file)
	dim i, tagn, tag, tagname
	dim msg
	msg = "Dateiname: " & file & vbCr & vbcr
	tagn = ubound(exifTagList,2)
	FF_LoadExif(file)
	for i=0 to tagn
		tagname = exifTagList(1,i)
		tag = FF_GetExifTag(exifTagList(0,i))
		
		'einige Umrechnungen
		if exifTagList(0,i) = "ExposureTime" then
			tag = formatExposureTime(tag)
		else
			tag = formatDate(tag)
		end if
		
		if Len(tagname) > 28 then
			msg = msg & tagname & ": " & vbTab & tag & vbCr
		elseif Len(tagname) > 18 then
			msg = msg & tagname & ": " & vbTab & vbTab & tag & vbCr		
		elseif Len(tagname) > 7 then
			msg = msg & tagname & ": " & vbTab & vbTab & vbTab & tag & vbCr
		else
			msg = msg & tagname & ": " & vbTab & vbTab & vbTab & vbTab & tag & vbCr
		end if
	next
	msgbox msg, vbInformation, "EXIF Suche - Anzeige der EXIF-Daten"
end sub

'*********************************************************
' exportCsv exportiert die Exifdaten eine Bilderliste
' in eine CSV-Datei, die z.B. mit Excel eingelesen werden kann
' pics: Array mit den Pfadnamen der Bilder
'*********************************************************
function exportCsv(pics)
	dim tPfad
	dim picn,i,j
	dim tagn, tag, tagname
	Dim fso, csvFile
	Const ForReading = 1, ForWriting = 2
	dim AF
	AF = chr(34)

	tPfad = FF_EnterFileName(false,"ExifTags.csv")
	if tPfad = "" then
		exit function
	end if

	tagn = ubound(exifTagList,2)
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set csvFile = fso.OpenTextFile(tPfad, ForWriting, True)
	for j=0 to tagn
		tagname = exifTagList(1,j)
		csvFile.Write AF & tagname & AF
		csvFile.Write ";"
	next
	csvFile.WriteLine AF & "Dateiname" & AF
	picn = ubound(pics)
	for i=0 to picn
		FF_SetProgress i, picn
		FF_LoadExif(pics(i))
		for j=0 to tagn
			tag = FF_GetExifTag(exifTagList(0,j))
			csvFile.Write AF & tag & AF
			csvFile.Write ";"
		next
		csvFile.WriteLine AF & pics(i) & AF
	next
	csvFile.Close
	msgbox picn+1 & " EXIF-Infos nach " & tPfad & " exportiert.", vbInformation, "EXIF Suche"
	set fso = nothing

end function

'*********************************************************
' copyPics kopiert die Bilder einer Liste in ein zu
' whlendes Zielverzeichnis
' pics: Array mit den Pfadnamen der Bilder
'*********************************************************
function copyPics(pics)
	dim tPfad
	dim picn,i
	dim overwrite
	dim ok

	tPfad = FF_EnterPath(true,"Zielverzeichnis auswhlen")
	if tPfad = "" then
		exit function
	end if
	picn = ubound(pics)
	overwrite = false
	for i=0 to picn
		FF_SetProgress i, picn
		ok = copyFileDir(pics(i), tPfad, overwrite)
		if not ok then
			msgbox "Bilder kopieren abgebrochen", vbExclamation, "EXIF Suche"
			exit function
		end if
	next
	msgbox picn+1 & " Bilder nach " & tPfad & " kopiert.", vbInformation, "EXIF Suche"

end function

'*********************************************************
' createBList erzeugt eine Bilderliste
' pics: Array mit den Pfadnamen der Bilder
'*********************************************************
function createBList(pics)
	dim picn,i
	dim ok
	Const BListName = "Search Exif"
	
	FF_IListDelete(BListName)
	FF_IListCreate(BListName)
	picn = ubound(pics)
	for i=0 to picn
		FF_SetProgress i, picn
		FF_IListInsertFile BListName, pics(i), i
	next
	FF_IListSave BListName
	msgbox picn+1 & " Bilder in Bilderliste '" & BListName & "' angelegt.", vbInformation, "EXIF Suche"

end function

'*********************************************************
' clsFindFile durchsucht rekursiv einen Dateibaum nach
' Dateinamen
'*********************************************************
Class clsFindFile

	private mvFso
	private mvRegEx

    ''''''''''''''''''''''''''''''''''''''''
	Private Sub Class_Initialize()
    ''''''''''''''''''''''''''''''''''''''''
		set mvFso=CreateObject("Scripting.FileSystemObject")
		Set mvRegEx = new regexp
	end sub

    ''''''''''''''''''''''''''''''''''''''''
	public sub findFiles(strFolder, pattern, recursive, byref fileList)
    ''''''''''''''''''''''''''''''''''''''''

		dim startFolder
		dim nfiles
		set startFolder=mvFso.GetFolder(strFolder)

		mvRegEx.Pattern = pattern
		mvRegEx.IgnoreCase = true
		nfiles = 0

		scanFolder startFolder, recursive, nFiles, fileList
	end sub

    ''''''''''''''''''''''''''''''''''''''''
	private sub scanFolder (byref folder, recursive, nFiles, byref fileList)
    ''''''''''''''''''''''''''''''''''''''''
		dim f, subF, FileName
		for each f in folder.Files
			on error resume next
			FileName = mvFso.GetBaseName(f) & "." & mvFso.GetExtensionName(f)
			if mvRegEx.Test(FileName) then
				redim preserve fileList(nFiles)
				fileList(nFiles) = f
				nFiles = nFiles + 1
			end if
		next
		if recursive then
			for each subF in folder.SubFolders
				scanFolder subF, recursive, nFiles, fileList
			next
		end if
	end sub

    ''''''''''''''''''''''''''''''''''''''''
	Private Sub Class_Terminate
    ''''''''''''''''''''''''''''''''''''''''
        Set mvFSO = Nothing
        Set mvRegEx = Nothing
	End Sub

end Class

'*********************************************************
' RegExpTest testet einen regulren Ausdruck an einer
' Zeichenkette
' strng : zu testende Zeichenkette
' patrn : regulrer Ausdruck
'*********************************************************
Function RegExpTest(strng, patrn)
	Dim regEx, retVal
	Set regEx = New RegExp
	
	regEx.Pattern = patrn
	regEx.IgnoreCase = true
	RegExpTest = regEx.Test(strng)
	Set regEx = Nothing
End Function

'*********************************************************
' SplitPath liefert Verzeichnis mit abschliessendem Backslash,
' Dateinamen und Erweiterung mit einleitendem Punkt
'*********************************************************
sub SplitPath(path, byref dirc, byref file, byref ext)
	dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")
	dirc = fso.GetParentFolderName(path) & "\"
	file = fso.GetBaseName(path)
	ext = "." & fso.GetExtensionName(path)
	Set fso = nothing
End Sub

'*********************************************************
' copyFileDir kopiert eine Datei in einen Zielordner
' file: Dateiname des Quellfiles
' targetDir: Zielverzeichnis
' overwrite: true=vorhandene Dateien berschreiben
'            false=nachfragen, wenn gleichnamige Dateien
'                  bereits im Zielverzeichnis existieren
'*********************************************************
function copyFileDir(file, targetDir, overwrite)
	dim fso, CFile
	dim fname, ext, jn
	copyFileDir = false
	Set fso = CreateObject("Scripting.FileSystemObject")
	on error resume next
	Set CFile = fso.GetFile(file)
	if err.number then
		MsgBox ("Error # " & CStr(Err.Number) & " " & Err.Description), vbExclamation, "EXIF Suche"
		exit function
	end if
	CFile.Copy targetDir & "\",overwrite
	if err.number then
		if err.number=58 then
			on error goto 0
			fname = fso.GetBaseName(file)
			ext = "." & fso.GetExtensionName(file)
			jn = msgbox ("Datei " & fname & ext & " existiert bereits in " & targetDir & vbCr & _
			"Vorhandene Dateien berschreiben?", vbYesNo + vbQuestion, "Dateien kopieren")
			if jn = vbYes then
				overwrite = true
				copyFileDir file, targetDir, overwrite
			else
				exit function
			end if
		else
			MsgBox ("Error # " & CStr(Err.Number) & " " & Err.Description), vbExclamation, "EXIF Suche"
		end if
	end if
	on error goto 0
	Set fso = nothing
	copyFileDir = true
end function

'*********************************************************
' checkt die aktuelle Version gegen eine minimal geforderte
' Version
' In:
' refBuild: Major.Minor.Build
' z.B.: "2.71.31"
' Out:
' CheckBuild: true oder false
'*********************************************************
function CheckBuild(refBuild)
	dim refver, aktver(2), i
	refver = split(refBuild,".",-1)
	for i=0 to 2
		refver(i) = cint(refver(i))
	next
	On Error Resume Next
	aktver(0) = FF_GetMajor()
	if err.number then
		CheckBuild = false
		exit function
	end if
	On Error goto 0
	aktver(1) = FF_GetMinor()
	aktver(2) = FF_GetBuild()
	If aktver(0) > refver(0) then
		CheckBuild = true
		exit function
	elseif aktver(0) = refver(0) then
		if aktver(1) > refver(1) then
			CheckBuild = true
			exit function
		elseif aktver(1) = refver(1) then
			if aktver(2) >= refver(2) then
				CheckBuild = true
				exit function
			end if
		else
			CheckBuild = false
			exit function
		end if
	else
		CheckBuild = false
		exit function
	end if
end function

'*********************************************************
' isExifNumberValue gibt das EXIF-Datum eine Zahl zurck?
'*********************************************************
Function isExifNumberValue(exifTag)
	Dim numberValues

	numberValues = "Altitude,ApertureValue,BrightnessValue,DateTime,DateTimeDigitized,DateTimeOriginal,ExposureProgram,ExposureBiasValue,ExposureTime,FNumber,FocalLengthFocalLengthIn35mmFilm,ISOSpeedRatings,ShutterSpeedValue,XResolution,YResolution"

	isExifNumberValue = (InStr(1, numberValues, exifTag) > 0)
	
End Function

'*********************************************************
' enabledOperator aktiviert/deaktiviert die 
'				  Operatorauswahl je nach EXIF-Tag
'*********************************************************
Function enabledOperator(dlg, obj, exifTagNo)
	Dim exif
	
	exif = exifTagList(0,exifTagNo)
	
	if not isExifNumberValue(exif) then
		FF_SetControl dlg, obj, operatorDef
		FF_EnableControl dlg, obj,  False
	else
		FF_EnableControl dlg, obj, True
	end if

End Function

'*********************************************************
' checkExifDate berprft gewhltes EXIF-Datum auf Wert
'*********************************************************
Function checkExifDate(exiftag, exif, wert, operator)
	Dim values
	Dim tmp
	Dim locExif
	Dim locWert
	Dim locTestValue
	
	if isExifNumberValue(exiftag) then
		if not IsDate(exif) then 
			locExif = Replace(exif, ".", ",")
		else
			locExif = exif
		end if
		if not IsDate(wert) then 
			locWert = Replace(wert, ".", ",")
		else
			locWert = wert
		end if
		
		'einige Umrechnungen
		if exiftag = "ExposureTime" then
		
			values = Split(locWert, "/")
			if UBound(values) > 0 then
				'FF_MessageBox  values(0) & vbcrlf & values(1), 64
				if IsNumeric(values(0)) and IsNumeric(values(1)) then
					locWert = CDbl(values(0)) / CDbl(values(1))
					locWert = round(locWert, 6)
				end if
			end if
		elseif exiftag = "DateTime" or exiftag = "DateTimeDigitized" or exiftag = "DateTimeOriginal" then

			locExif = formatDate(exif)
		end if

		if IsNumeric(locExif) and IsNumeric(locWert) then
			if operator = "=" then
				if CDbl(locExif) = CDbl(locWert) then checkExifDate = true
			elseif operator = ">" then
				if CDbl(locExif) > CDbl(locWert) then checkExifDate = true
			elseif operator = "<" then
				if CDbl(locExif) < CDbl(locWert) then checkExifDate = true
			elseif operator = ">=" then
				if CDbl(locExif) >= CDbl(locWert) then checkExifDate = true
			elseif operator = "<=" then
				if CDbl(locExif) <= CDbl(locWert) then checkExifDate = true
			end if
		elseif IsDate(locExif) and IsDate(locWert) then
			locTestValue = CDate(locWert)
			locTestValue = Hour(locTestValue) + Minute(locTestValue) + Second(locTestValue)
			
			if operator = "=" then
				if (locTestValue = 0) then 
					if CDate(locExif) >= CDate(locWert & " 00:00:00") and CDate(locExif) <= CDate(locWert & " 23:59:59") then checkExifDate = true
				else
					if CDate(locExif) = CDate(locWert) then checkExifDate = true
				end if
			elseif operator = ">" then
				if (locTestValue = 0) then locWert = CStr((CDate(locWert) + 1)) & " 00:00:00"
				if CDate(locExif) > CDate(locWert) then checkExifDate = true
			elseif operator = "<" then
				if (locTestValue = 0) then locWert = CStr((CDate(locWert) - 1)) & " 23:59:59"
				if CDate(locExif) < CDate(locWert) then checkExifDate = true
			elseif operator = ">=" then
				if (locTestValue = 0) then locWert = locWert & " 00:00:00"
				if CDate(locExif) >= CDate(locWert) then checkExifDate = true
			elseif operator = "<=" then
				if (locTestValue = 0) then locWert = locWert & " 23:59:59"
				if CDate(locExif) <= CDate(locWert) then checkExifDate = true
			end if
		else
			exif = Replace(exif, vbCrLf, " ")
			if RegExpTest(exif, wert) then checkExifDate = true
		end if								
	else
		exif = Replace(exif, vbCrLf, " ")
		if RegExpTest(exif, wert) then checkExifDate = true
	end if
	
End Function

'*********************************************************
' formatDate EXIF-Datum in konvertierbares Datum wandeln
'*********************************************************
Function formatDate(value)
	Dim result
	Dim datum
	Dim zeit
	
	result = value
	if Len(result) > 10 then
		if InStr(1, result, ":") = 5 and InStr(6, result, ":") = 8 and InStr(1, result, " ") = 11 then
			datum = Left(result, 10)
			datum = Replace(datum, ":", "/")
			zeit = Mid(result, 12, Len(result))
			
			result = CDate(datum & " " & zeit)
			'FF_Messagebox CDate(datum & " " & zeit), 0
		end if
	end if
	
	formatDate = result
	
End Function

Function formatExposureTime(value)
	Dim result
	
	result = value
	
	result = Replace(result, ".", ",")
	if IsNumeric(result) then		
		if CDbl(result) > 0 then
			if CDbl(result) < 1 then 
				result = "1/" & CLng(1 / CDbl(result))  & " (" & Replace(FormatNumber(result, 4), ",", ".") & ")"
			else
				result = CDbl(result)
				result = FormatNumber(result, 1)
				result = Replace(result, ",", ".")
				'if InStr(1, result, ".") = 0 then result = result & ".0"
			end if
		end if
	end if

	formatExposureTime = result
	
End Function